stages:
  - lint
  - test

.install-dependencies: &install-dependencies
  before_script:
    - bash ci/docker_install.sh > /dev/null

.cache-dependencies: &cache-dependencies
  cache:
    key: "$CI_JOB_NAME-$CI_JOB_STAGE"
    untracked: true
    paths:
      - ./vendor/

lint:
  image: php:8.0
  stage: lint
  <<: *cache-dependencies
  <<: *install-dependencies
  script:
    - ./vendor/bin/php-cs-fixer fix --config=.php-cs-fixer.dist.php -v --dry-run --stop-on-violation --using-cache=no --allow-risky=yes --diff ./
  interruptible: true

test:
  image: php:8.0
  stage: test
  <<: *cache-dependencies
  <<: *install-dependencies
  script:
    - ./vendor/bin/phpunit --bootstrap ./vendor/autoload.php tests
  interruptible: true
